const props = {}
props.name = 'With Validation'

// * Higher order component used to add validation capabilities to a form input.
// * @param {Component} WrappedComponent - preact component to add validation
// * @prop {String|Function} validate - string (not-emtpy, email, checked)
// * or custom function used to validate input. function is called with the value
// * of the field.
// * @prop {Function} onValidityChange - function called with the validity
// * status and message when the valdidity of the input changes.
// * @prop {Boolean} forceValidate - any time this value is set to true, the
// * field will validate, even if its content has not changed.
// * @return {Component} the same component you passed in, with validation

// TODO
props.default = [
  {
    name: 'WrappedComponent',
    type: 'component',
    description: 'preact component to add validation'
    // value: ???
  }
]

// TODO
// props.variants = [
//   {
//     name: 'Error',
//     props: [
//       { name: 'tag_color', value: 'error-red' },
//       { name: 'text', value: 'This is an error.' },
//       { name: 'text_color', value: 'dark' },
//       { name: 'tag', value: 'Error!' },
//       { name: 'url', value: 'https://hashicorp.com' }
//     ]
//   },
//   {
//     name: 'Warning',
//     props: [
//       { name: 'tag_color', value: 'warning-yellow' },
//       { name: 'text', value: 'This is an warning.' },
//       { name: 'text_color', value: 'dark' },
//       { name: 'tag', value: 'Warning!' },
//       { name: 'url', value: 'https://hashicorp.com' }
//     ]
//   }
// ]

export default props
